/****************************************************************************
 ** This file is part of the MAIA (Malagasy Artificial Intelligence Art) Open Project V2.0.
 **
 ** Copyright (C) 2012 ANDRIAMILAMINA Monge.
 ** All rights reserved.
 **
 ** License: GNU GENERAL PUBLIC LICENSE Version 3, 29 June 2007.
 ** Author:  ANDRIAMILAMINA Monge.
 ** Contact: mongemilamina@gmail.com / +261 32 04 309 92.
 ** Year:    2012.
 ** Status:  Student in ISGEI, Madagasikara, Antananarivo.
 ** Domain:  Automatic.
 **
 ** Commercial Usage
 ** Please contact MAIA.
 **
 ** GNU General Public License Usage
 ** This file may be used under the terms of the GNU
 ** General Public License version 3.0 as published by the Free Software
 ** Foundation and appearing in the file LICENSE.GPL included in the
 ** packaging of this file.  Please review the following information to
 ** ensure the GNU General Public License version 3.0 requirements will be
 ** met: http://www.gnu.org/copyleft/gpl.html.
 **
 ** If you have questions regarding the use of this file, please contact
 ** the Author.
 **
 ****************************************************************************/

#include "porttohex.h"
#include "ui_porttohex.h"
#include <iostream>

using namespace::std;

PortToHex::PortToHex(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::PortToHex)
{
    ui->setupUi(this);
    ui->line_text->selectAll();

    ui->b_clear->setShortcut(Qt::CTRL+Qt::Key_L);

    connect(ui->line_text, SIGNAL(textEdited(QString)), this, SLOT(convert_()));
    connect(ui->b_clear, SIGNAL(clicked()), this, SLOT(clear()));
}
//#############################################################
void PortToHex::clear()
{
    ui->line_text->clear();
    ui->line_hex->clear();
    ui->line_bin->clear();
}
//#############################################################
void PortToHex::convert_()
{
    QString gotText = ui->line_text->text().right(1);
//..............LETTER UPPERCASE..............................
    if (gotText == "A")
    {
        ui->line_hex->insert("41 ");
        ui->line_bin->insert("01000001 ");
    }
    else if (gotText == "B")
    {
        ui->line_hex->insert("42 ");
        ui->line_bin->insert("01000010 ");
    }
    else if (gotText == "C")
    {
        ui->line_hex->insert("43 ");
        ui->line_bin->insert("01000011 ");
    }
    else if (gotText == "D")
    {
        ui->line_hex->insert("44 ");
        ui->line_bin->insert("01000100 ");
    }
    else if (gotText == "E")
    {
        ui->line_hex->insert("45 ");
        ui->line_bin->insert("01000101 ");
    }
    else if (gotText == "F")
    {
        ui->line_hex->insert("46 ");
        ui->line_bin->insert("01000110 ");
    }
    else if (gotText == "G")
    {
        ui->line_hex->insert("47 ");
        ui->line_bin->insert("01000111 ");
    }
    else if (gotText == "H")
    {
        ui->line_hex->insert("48 ");
        ui->line_bin->insert("01001000 ");
    }
    else if (gotText == "I")
    {
        ui->line_hex->insert("49 ");
        ui->line_bin->insert("01001001 ");
    }
    else if (gotText == "J")
    {
        ui->line_hex->insert("4A ");
        ui->line_bin->insert("01001010 ");
    }
    else if (gotText == "K")
    {
        ui->line_hex->insert("4B ");
        ui->line_bin->insert("01001011 ");
    }
    else if (gotText == "L")
    {
        ui->line_hex->insert("4C ");
        ui->line_bin->insert("01001100 ");
    }
    else if (gotText == "M")
    {
        ui->line_hex->insert("4D ");
        ui->line_bin->insert("01001101 ");
    }
    else if (gotText == "N")
    {
        ui->line_hex->insert("4E ");
        ui->line_bin->insert("01001110 ");
    }
    else if (gotText == "O")
    {
        ui->line_hex->insert("4F ");
        ui->line_bin->insert("01001111 ");
    }
    else if (gotText == "P")
    {
        ui->line_hex->insert("50 ");
        ui->line_bin->insert("01010000 ");
    }
    else if (gotText == "Q")
    {
        ui->line_hex->insert("51 ");
        ui->line_bin->insert("01010001 ");
    }
    else if (gotText == "R")
    {
        ui->line_hex->insert("52 ");
        ui->line_bin->insert("01010010 ");
    }
    else if (gotText == "S")
    {
        ui->line_hex->insert("53 ");
        ui->line_bin->insert("01010011 ");
    }
    else if (gotText == "T")
    {
        ui->line_hex->insert("54 ");
        ui->line_bin->insert("01010100 ");
    }
    else if (gotText == "U")
    {
        ui->line_hex->insert("55 ");
        ui->line_bin->insert("01010101 ");
    }
    else if (gotText == "V")
    {
        ui->line_hex->insert("56 ");
        ui->line_bin->insert("01010110 ");
    }
    else if (gotText == "W")
    {
        ui->line_hex->insert("57 ");
        ui->line_bin->insert("01010111 ");
    }
    else if (gotText == "X")
    {
        ui->line_hex->insert("58 ");
        ui->line_bin->insert("01011000 ");
    }
    else if (gotText == "Y")
    {
        ui->line_hex->insert("59 ");
        ui->line_bin->insert("01011001 ");
    }
    else if (gotText == "Z")
    {
        ui->line_hex->insert("5A ");
        ui->line_bin->insert("01011010 ");
    }
//..............LETTER LOWERCASE..............................
    else if (gotText == "a")
    {
        ui->line_hex->insert("61 ");
        ui->line_bin->insert("01100001 ");
    }
    else if (gotText == "b")
    {
        ui->line_hex->insert("62 ");
        ui->line_bin->insert("01100010 ");
    }
    else if (gotText == "c")
    {
        ui->line_hex->insert("63 ");
        ui->line_bin->insert("01100011 ");
    }
    else if (gotText == "d")
    {
        ui->line_hex->insert("64 ");
        ui->line_bin->insert("01100100 ");
    }
    else if (gotText == "e")
    {
        ui->line_hex->insert("65 ");
        ui->line_bin->insert("01100101 ");
    }
    else if (gotText == "f")
    {
        ui->line_hex->insert("66 ");
        ui->line_bin->insert("01100110 ");
    }
    else if (gotText == "g")
    {
        ui->line_hex->insert("67 ");
        ui->line_bin->insert("01100111 ");
    }
    else if (gotText == "h")
    {
        ui->line_hex->insert("68 ");
        ui->line_bin->insert("01101000 ");
    }
    else if (gotText == "i")
    {
        ui->line_hex->insert("69 ");
        ui->line_bin->insert("01101001 ");
    }
    else if (gotText == "j")
    {
        ui->line_hex->insert("6A ");
        ui->line_bin->insert("01101010 ");
    }
    else if (gotText == "k")
    {
        ui->line_hex->insert("6B ");
        ui->line_bin->insert("01101011 ");
    }
    else if (gotText == "l")
    {
        ui->line_hex->insert("6C ");
        ui->line_bin->insert("01101100 ");
    }
    else if (gotText == "m")
    {
        ui->line_hex->insert("6D ");
        ui->line_bin->insert("01101101 ");
    }
    else if (gotText == "n")
    {
        ui->line_hex->insert("6E ");
        ui->line_bin->insert("01101110 ");
    }
    else if (gotText == "o")
    {
        ui->line_hex->insert("6F ");
        ui->line_bin->insert("01101111 ");
    }
    else if (gotText == "p")
    {
        ui->line_hex->insert("70 ");
        ui->line_bin->insert("01110000 ");
    }
    else if (gotText == "q")
    {
        ui->line_hex->insert("71 ");
        ui->line_bin->insert("01110001 ");
    }
    else if (gotText == "r")
    {
        ui->line_hex->insert("72 ");
        ui->line_bin->insert("01110010 ");
    }
    else if (gotText == "s")
    {
        ui->line_hex->insert("73 ");
        ui->line_bin->insert("01110011 ");
    }
    else if (gotText == "t")
    {
        ui->line_hex->insert("74 ");
        ui->line_bin->insert("01110100 ");
    }
    else if (gotText == "u")
    {
        ui->line_hex->insert("75 ");
        ui->line_bin->insert("01110101 ");
    }
    else if (gotText == "v")
    {
        ui->line_hex->insert("76 ");
        ui->line_bin->insert("01110110 ");
    }
    else if (gotText == "w")
    {
        ui->line_hex->insert("77 ");
        ui->line_bin->insert("01110111 ");
    }
    else if (gotText == "x")
    {
        ui->line_hex->insert("78 ");
        ui->line_bin->insert("01111000 ");
    }
    else if (gotText == "y")
    {
        ui->line_hex->insert("79 ");
        ui->line_bin->insert("01111001 ");
    }
    else if (gotText == "z")
    {
        ui->line_hex->insert("7A ");
        ui->line_bin->insert("01111010 ");
    }
//..............numbers..............................
    else if (gotText == "0")
    {
        ui->line_hex->insert("30 ");
        ui->line_bin->insert("00110001 ");
    }
    else if (gotText == "1")
    {
        ui->line_hex->insert("31 ");
        ui->line_bin->insert("00110010 ");
    }
    else if (gotText == "2")
    {
        ui->line_hex->insert("32 ");
        ui->line_bin->insert("00110011 ");
    }
    else if (gotText == "3")
    {
        ui->line_hex->insert("33 ");
        ui->line_bin->insert("00110100 ");
    }
    else if (gotText == "4")
    {
        ui->line_hex->insert("34 ");
        ui->line_bin->insert("00110101 ");
    }
    else if (gotText == "5")
    {
        ui->line_hex->insert("35 ");
        ui->line_bin->insert("00110110 ");
    }
    else if (gotText == "6")
    {
        ui->line_hex->insert("36 ");
        ui->line_bin->insert("00110111 ");
    }
    else if (gotText == "7")
    {
        ui->line_hex->insert("37 ");
        ui->line_bin->insert("00111000 ");
    }
    else if (gotText == "8")
    {
        ui->line_hex->insert("38 ");
        ui->line_bin->insert("00111001 ");
    }
    else if (gotText == "9")
    {
        ui->line_hex->insert("39 ");
        ui->line_bin->insert("00111010 ");
    }
//..............spec char..............................
    else if (gotText == "!")
    {
        ui->line_hex->insert("21 ");
        ui->line_bin->insert("00100001 ");
    }
    else if (gotText == "\"")//escape double quote with back slash
    {
        ui->line_hex->insert("22 ");
        ui->line_bin->insert("00100010 ");
    }
    else if (gotText == "#")
    {
        ui->line_hex->insert("23 ");
        ui->line_bin->insert("00100011 ");
    }
    else if (gotText == "$")
    {
        ui->line_hex->insert("24 ");
        ui->line_bin->insert("00100100 ");
    }
    else if (gotText == "%")
    {
        ui->line_hex->insert("25 ");
        ui->line_bin->insert("00100101 ");
    }
    else if (gotText == "&")
    {
        ui->line_hex->insert("26 ");
        ui->line_bin->insert("00100110 ");
    }
    else if (gotText == "'")
    {
        ui->line_hex->insert("27 ");
        ui->line_bin->insert("00100111 ");
    }
    else if (gotText == "(")
    {
        ui->line_hex->insert("28 ");
        ui->line_bin->insert("00101000 ");
    }
    else if (gotText == ")")
    {
        ui->line_hex->insert("29 ");
        ui->line_bin->insert("00101001 ");
    }
    else if (gotText == "*")
    {
        ui->line_hex->insert("2A ");
        ui->line_bin->insert("00101010 ");
    }
    else if (gotText == "+")
    {
        ui->line_hex->insert("2B ");
        ui->line_bin->insert("00101011 ");
    }
    else if (gotText == ",")
    {
        ui->line_hex->insert("2C ");
        ui->line_bin->insert("00101100 ");
    }
    else if (gotText == "-")
    {
        ui->line_hex->insert("2D ");
        ui->line_bin->insert("00101101 ");
    }
    else if (gotText == ".")
    {
        ui->line_hex->insert("2E ");
        ui->line_bin->insert("00101110 ");
    }
    else if (gotText == "/")
    {
        ui->line_hex->insert("2F ");
        ui->line_bin->insert("00101111 ");
    }
    else if (gotText == ":")
    {
        ui->line_hex->insert("3A ");
        ui->line_bin->insert("00111010 ");
    }
    else if (gotText == ";")
    {
        ui->line_hex->insert("3B ");
        ui->line_bin->insert("00111011 ");
    }
    else if (gotText == "<")
    {
        ui->line_hex->insert("3C ");
        ui->line_bin->insert("00111100 ");
    }
    else if (gotText == "=")
    {
        ui->line_hex->insert("3D ");
        ui->line_bin->insert("00111101 ");
    }
    else if (gotText == ">")
    {
        ui->line_hex->insert("3E ");
        ui->line_bin->insert("00111110 ");
    }
    else if (gotText == "?")
    {
        ui->line_hex->insert("3F ");
        ui->line_bin->insert("00111111 ");
    }
    else if (gotText == "@")
    {
        ui->line_hex->insert("40 ");
        ui->line_bin->insert("01000000 ");
    }
    else if (gotText == "[")
    {
        ui->line_hex->insert("5B ");
        ui->line_bin->insert("01011011 ");
    }
    else if (gotText == "\\")//escape back slash with himself
    {
        ui->line_hex->insert("5C ");
        ui->line_bin->insert("01011100 ");
    }
    else if (gotText == "]")
    {
        ui->line_hex->insert("5D ");
        ui->line_bin->insert("01011101 ");
    }
    else if (gotText == "^")
    {
        ui->line_hex->insert("5E ");
        ui->line_bin->insert("01011110 ");
    }
    else if (gotText == "_")
    {
        ui->line_hex->insert("5F ");
        ui->line_bin->insert("01011111 ");
    }
    else if (gotText == "{")
    {
        ui->line_hex->insert("7B ");
        ui->line_bin->insert("01111011 ");
    }
    else if (gotText == "|")
    {
        ui->line_hex->insert("7C ");
        ui->line_bin->insert("01111100 ");
    }
    else if (gotText == "}")
    {
        ui->line_hex->insert("7D ");
        ui->line_bin->insert("01111101 ");
    }
    else if (gotText == "~")
    {
        ui->line_hex->insert("7E ");
        ui->line_bin->insert("01111110 ");
    }
}
//#############################################################
PortToHex::~PortToHex()
{
    delete ui;
}
